﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace SampleApplication
{
    public partial class Form1 : MetroForm
    {
        //Create dataTable
        public DataTable dt = null;

        public Form1()
        {

            InitializeComponent();

            this.gridGroupingControl1.GridVisualStyles = GridVisualStyles.Metro;
            
            this.gridGroupingControl1.BrowseOnly = true;
            this.gridGroupingControl1.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.HideAlways;
            this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.HideCurrentCell;
            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One;
            this.gridGroupingControl1.TableOptions.SelectionBackColor = Color.Gray;
            this.gridGroupingControl1.FreezeCaption = false;
            //this.gridGroupingControl1.TableDescriptor.Columns["Amount"].Width = (this.tableLayoutPanel3.Width / 5) - 50;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyCell.VerticalAlignment = GridVerticalAlignment.Middle;
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyCell.HorizontalAlignment = GridHorizontalAlignment.Center;

            this.gridGroupingControl1.Table.DefaultColumnHeaderRowHeight = 30;
            this.gridGroupingControl1.Table.DefaultRecordRowHeight = 40;
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyCell.Font.Size = 10f;
            dt = new DataTable("Table1");
            dt.Columns.Add("Name");
            dt.Columns.Add("Car");
            dt.Columns.Add("Place");
            dt.Columns.Add("Price");
            // Create a Data Set
            DataSet ds = new DataSet();
            ds.Tables.Add(dt);
            dt.Rows.Add(new string[] { "Alex", "Audi", "Italy", "$90000" });
            dt.Rows.Add(new string[] { "Bob", "Benz", "London", "$18000" });
            dt.Rows.Add(new string[] { "Alice", "Toyoto", "US", "$70000" });
            dt.Rows.Add(new string[] { "Adlensha", "Ferrari", "Italy", "$50000" });
            dt.Rows.Add(new string[] { "Brick", "Lambogini", "North America" ,"$190000"});
            dt.Rows.Add(new string[] { "Collen", "Jaguar", "India", "$99000" });
            DataView view = new DataView(dt);
            this.gridGroupingControl1.DataSource = dt;

            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One;
        }

        private void buttonAdv1_Click(object sender, EventArgs e)
        {
            EditForm form = new EditForm();
            form.ShowDialog();
            if (form.IsUpdated)
            {
                this.gridGroupingControl1.Table.AddNewRecord.BeginEdit();
                this.gridGroupingControl1.Table.AddNewRecord.SetValue("Name", form.textBoxExt1.Text);
                this.gridGroupingControl1.Table.AddNewRecord.SetValue("Car", form.comboBoxAdv1.Text);
                this.gridGroupingControl1.Table.AddNewRecord.SetValue("Place", form.textBoxExt3.Text);
                this.gridGroupingControl1.Table.AddNewRecord.SetValue("Price", form.textBoxExt4.Text);

                this.gridGroupingControl1.Table.AddNewRecord.EndEdit();
            }
        }

        private void buttonAdv2_Click(object sender, EventArgs e)
        {
            EditForm form = new EditForm();
            foreach (SelectedRecord selectedRecord in this.gridGroupingControl1.Table.SelectedRecords)
            {
                form.textBoxExt1.Text = selectedRecord.Record["Name"].ToString();
                form.comboBoxAdv1.Text = selectedRecord.Record["Car"].ToString();
                //form.textBoxExt2.Text = selectedRecord.Record["Car"].ToString();
                form.textBoxExt3.Text = selectedRecord.Record["Place"].ToString();
                form.textBoxExt4.Text = selectedRecord.Record["Price"].ToString();
            }

            form.ShowDialog();
            if (form.IsUpdated)
            {
                foreach (SelectedRecord selectedRecord in this.gridGroupingControl1.Table.SelectedRecords)
                {
                    foreach (GridColumnDescriptor column in this.gridGroupingControl1.TableDescriptor.Columns)
                    {
                        selectedRecord.Record.SetValue("Name", form.textBoxExt1.Text);

                        selectedRecord.Record.SetValue("Car", form.comboBoxAdv1.Text);
                        selectedRecord.Record.SetValue("Place", form.textBoxExt3.Text);
                        selectedRecord.Record.SetValue("Price", form.textBoxExt4.Text);
                    }
                }
            }
        }

        private void buttonAdv3_Click(object sender, EventArgs e)
        {
            foreach (Syncfusion.Grouping.SelectedRecord record in this.gridGroupingControl1.Table.SelectedRecords)
            {
                record.Record.Delete();
            }
        }

        private void buttonAdv4_Click(object sender, EventArgs e)
        {

        }
    }
}
